function PrinterPagSeguro(){

    var self = this;

    var INVALID_PRINTER_INSTANCE = 'Não foi possível chamar a impressora. Sua instância não existe.';

    this.printText = function(text){

        if (!!window.cordova && !!window.cordova.plugins.IntegrationService){

        	var params = JSON.stringify({"texto":text,
        	                              "flag":"printText"});
            //Chamada da função de impressão da integração
            //window.returnPrintResult contém a função printResult desse mesmo arquivo
            window.cordova.plugins.IntegrationService.print(params, window.returnPrintResult,null);

        } else {
        	window.returnPrintResult(self.invalidPrinterInstance());
        }
    };

    this.printQRCode = function(qrCode){

        var params = JSON.stringify({"qrcode":qrCode,
                                     "flag":"qrCode"});
        window.cordova.plugins.IntegrationService.print(params, window.returnPrintResult,null);

    };

    this.printBarCode = function(barCode){

        var params = JSON.stringify({"barcode":barCode,
                                     "flag":"barCode"});
        window.cordova.plugins.IntegrationService.print(params, window.returnPrintResult,null);

    };

    this.reprintTEFVoucher = function(){

       window.returnPrintResult(self.invalidPrinterInstance());
    };


    this.printResult = function(resolve, javaResult){
        console.log(javaResult);
        javaResult = self.codeToString(javaResult);
        resolve(javaResult);
    };

    this.printerDelay = function(){
        setTimeout(function(){
        	var returnObj = self.formatResponse();
        	returnObj.error = false;
        	window.returnPrintResult(JSON.stringify(returnObj));
        }.bind(this),5000);
    };

    this.invalidPrinterInstance = function(){
        return JSON.stringify({
            'error': true,
            'message': INVALID_PRINTER_INSTANCE
        });
    };

    this.formatResponse = null;

    this.codeToString = function(javaResult){
        switch(javaResult.message){
            case 0: javaResult.message = "Transação concluída com sucesso."; break;
            case 1001: javaResult.message = "Mensagem gerada maior que buffer dimensionado."; break;
            case 1002: javaResult.message = "Parâmetro de aplicação inválido."; break;
            case 1003: javaResult.message = "Terminal não está pronto para transacionar.	Tente novamente."; break;
            case 1004: javaResult.message = "Transação não realizada."; break;
            case 1005: javaResult.message = "Buffer de resposta da transação inválido ao obter as informações de resultado da transação."; break;
            case 1006: javaResult.message = "Parâmetro de valor da transação não pode ser nulo."; break;
            case 1007: javaResult.message = "Parâmetro de valor total da transação não pode ser nulo."; break;
            case 1008: javaResult.message = "Parâmetro de código de venda não pode ser nulo."; break;
            case 1009: javaResult.message = "Parâmetro de resultado da transação não pode ser nulo."; break;
            case 1010: javaResult.message = "Driver de conexão não encontrado."; break;
            case 1011: javaResult.message = "Erro ao utilizar driver de conexão."; break;
            case 1012: javaResult.message = "Formato do valor da venda inválido."; break;
            case 1013: javaResult.message = "Comprimento do código de venda superior a 10 dígitos."; break;
            case 1014: javaResult.message = "Buffer de recepção corrompido."; break;
            case 1015: javaResult.message = "Nome da aplicação maior que 25 caracteres."; break;
            case 1016: javaResult.message = "Versão da aplicação maior que 10 caracteres."; break;
            case 1017: javaResult.message = "Necessário definir nome da aplicação."; break;
            case 1018: javaResult.message = "Não existem dados da última transação."; break;
            case 1019: javaResult.message = "Erro de comunicação com terminal (resposta inesperada)."; break;
            case 1024: javaResult.message = "Erro na carga de tabelas."; break;
            case 1030: javaResult.message = "Token não encontrado"; break;
            case 1031: javaResult.message = "Valor inválido"; break;
            case 1032: javaResult.message = "Parcelamento inválido"; break;
            case 2001: javaResult.message = "Porta COM informada não encontrada."; break;
            case 2002: javaResult.message = "Não foi possível obter configurações da porta COM informada."; break;
            case 2003: javaResult.message = "Não foi possível configurar a porta COM informada."; break;
            case 2005: javaResult.message = "Não foi possível enviar dados pela porta COM informada."; break;
            case 2022: javaResult.message = "Java – Adaptador Null."; break;
            case 2023: javaResult.message = "Java – erro em DeviceToUse."; break;
            case 2024: javaResult.message = "Java – erro no serviço RfcommSocket."; break;
            case 2026: javaResult.message = "Java – Close exception."; break;
            case 3001: javaResult.message = "Permissão de root"; break;
            case 4046: javaResult.message = "Não existem dados de autenticação"; break;
            case -5027 :
            case 5027  : javaResult.message = "Sem papel"; break;
            case null: javaResult.message = "Não foi possível definir o erro"; break;
        }
        return javaResult;
    };

}


Configuration(function(ContextRegister) {
	ContextRegister.register('PrinterPagSeguro', PrinterPagSeguro);
});